Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs	(revision 2540)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs	(revision 2541)
@@ -33,4 +33,6 @@
 namespace HeuristicLab.MainForm.WindowsForms {
   public partial class MainFormBase : Form, IMainForm {
+
+    private bool initialized;
     protected MainFormBase()
       : base() {
@@ -38,4 +40,5 @@
       this.views = new Dictionary<IView, Form>();
       this.userInterfaceItems = new List<IUserInterfaceItem>();
+      this.initialized = false;
     }
 
@@ -44,11 +47,18 @@
       this.userInterfaceItemType = userInterfaceItemType;
       CreateGUI();
-      OnMainFormChanged();
     }
 
     private void MainFormBase_Load(object sender, EventArgs e) {
-      if (!DesignMode)
+      if (!DesignMode) {
         MainFormManager.RegisterMainForm(this);
-    }
+        if (!this.initialized) {
+          this.initialized = true;
+          if (this.Initialized != null)
+            this.Initialized(this,new EventArgs());
+        }
+      }
+    }
+
+    public event EventHandler Initialized;
 
     #region IMainForm Members
@@ -239,5 +249,5 @@
         this.InsertItem(menuItem.Structure, typeof(ToolStripMenuItem), new ToolStripSeparator(), menuStrip.Items);
       }
-     }
+    }
 
     private void AddToolStripButtonItem(IToolBarItem buttonItem) {
@@ -253,7 +263,7 @@
         item.DisplayStyle = ((ToolBarItemBase)buttonItem).ToolStripItemDisplayStyle;
         ((ToolBarItemBase)buttonItem).ToolStripItem = item;
-      } else if (buttonItem is IToolBarSeparatorItem) 
+      } else if (buttonItem is IToolBarSeparatorItem)
         item = new ToolStripSeparator();
-      
+
       this.InsertItem(buttonItem.Structure, typeof(ToolStripDropDownButton), item, toolStrip.Items);
     }
@@ -281,4 +291,5 @@
       this.ActiveViewChanged += new EventHandler(userInterfaceItem.ActiveViewChanged);
       this.Changed += new EventHandler(userInterfaceItem.MainFormChanged);
+      this.Initialized += new EventHandler(userInterfaceItem.MainFormInitialized);
       toolStripItem.Click += new EventHandler(ToolStripItemClicked);
       this.userInterfaceItems.Add(userInterfaceItem);
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ToolBarItemBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ToolBarItemBase.cs	(revision 2540)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ToolBarItemBase.cs	(revision 2541)
@@ -24,5 +24,5 @@
 using System.Text;
 using System.Windows.Forms;
-                                                            
+
 namespace HeuristicLab.MainForm.WindowsForms {
   public abstract class ToolBarItemBase : HeuristicLab.MainForm.ToolBarItemBase {
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewBase.cs	(revision 2540)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewBase.cs	(revision 2541)
@@ -69,10 +69,10 @@
     }
 
-    public event EventHandler Initialize;
+    public event EventHandler Initialized;
 
     private void ViewBase_Load(object sender, EventArgs e) {
       if (!this.initialized && !this.DesignMode) {
-        if (this.Initialize != null)
-          this.Initialize(this, new EventArgs());
+        if (this.Initialized != null)
+          this.Initialized(this, new EventArgs());
         this.initialized = true;
       }
Index: trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IUserInterfaceItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IUserInterfaceItem.cs	(revision 2540)
+++ trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IUserInterfaceItem.cs	(revision 2541)
@@ -38,4 +38,5 @@
     void ViewChanged(object sender, EventArgs e);
     void MainFormChanged(object sender, EventArgs e);
+    void MainFormInitialized(object sender, EventArgs e);
   }
 }
Index: trunk/sources/HeuristicLab.MainForm/3.2/MenuSeparatorItemBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MenuSeparatorItemBase.cs	(revision 2540)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MenuSeparatorItemBase.cs	(revision 2541)
@@ -37,4 +37,8 @@
       throw new NotImplementedException();
     }
+
+    public void MainFormInitialized(object sender, EventArgs e) {
+      throw new NotImplementedException();
+    }
   }
 }
Index: trunk/sources/HeuristicLab.MainForm/3.2/ToolBarSeparatorItemBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/ToolBarSeparatorItemBase.cs	(revision 2540)
+++ trunk/sources/HeuristicLab.MainForm/3.2/ToolBarSeparatorItemBase.cs	(revision 2541)
@@ -39,4 +39,8 @@
       throw new NotImplementedException();
     }
+
+    public void MainFormInitialized(object sender, EventArgs e) {
+      throw new NotImplementedException();
+    }
   }
 }
Index: trunk/sources/HeuristicLab.MainForm/3.2/UserInterfaceItemBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/UserInterfaceItemBase.cs	(revision 2540)
+++ trunk/sources/HeuristicLab.MainForm/3.2/UserInterfaceItemBase.cs	(revision 2541)
@@ -51,4 +51,7 @@
     public virtual void MainFormChanged(object sender, EventArgs e) {
     }
+
+    public virtual void MainFormInitialized(object sender, EventArgs e) {
+    }
   }
 }