Index: /branches/Persistence Test/HeuristicLab.sln
===================================================================
--- /branches/Persistence Test/HeuristicLab.sln	(revision 2564)
+++ /branches/Persistence Test/HeuristicLab.sln	(revision 2565)
@@ -77,4 +77,8 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Common-3.2", "HeuristicLab.Common\3.2\HeuristicLab.Common-3.2.csproj", "{1FC004FC-59AF-4249-B1B6-FF25873A20E4}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.BackgroundProcessing-3.2", "HeuristicLab.BackgroundProcessing\3.2\HeuristicLab.BackgroundProcessing-3.2.csproj", "{589BECAE-69B0-4EB1-8C06-C073531762B7}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.MainForm-3.2", "HeuristicLab.MainForm\3.2\HeuristicLab.MainForm-3.2.csproj", "{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}"
 EndProject
 Global
@@ -1087,4 +1091,76 @@
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|x86.ActiveCfg = Debug|x86
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|x86.Build.0 = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.CEDMA Debug|x64.ActiveCfg = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.CEDMA Debug|x64.Build.0 = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.CEDMA Debug|x86.ActiveCfg = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.CEDMA Debug|x86.Build.0 = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Debug|x64.ActiveCfg = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Debug|x64.Build.0 = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Debug|x86.ActiveCfg = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Debug|x86.Build.0 = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Modeling Debug|x64.ActiveCfg = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Modeling Debug|x64.Build.0 = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Modeling Debug|x86.Build.0 = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Release|Any CPU.Build.0 = Release|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Release|x64.ActiveCfg = Release|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Release|x64.Build.0 = Release|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Release|x86.ActiveCfg = Release|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Release|x86.Build.0 = Release|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.v3.2 Debug|x64.ActiveCfg = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.v3.2 Debug|x64.Build.0 = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.v3.2 Debug|x86.Build.0 = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Visualization Debug|x64.ActiveCfg = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Visualization Debug|x64.Build.0 = Debug|x64
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Visualization Debug|x86.ActiveCfg = Debug|x86
+		{589BECAE-69B0-4EB1-8C06-C073531762B7}.Visualization Debug|x86.Build.0 = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.CEDMA Debug|x64.ActiveCfg = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.CEDMA Debug|x64.Build.0 = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.CEDMA Debug|x86.ActiveCfg = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.CEDMA Debug|x86.Build.0 = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Debug|x64.ActiveCfg = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Debug|x64.Build.0 = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Debug|x86.ActiveCfg = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Debug|x86.Build.0 = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Modeling Debug|x64.ActiveCfg = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Modeling Debug|x64.Build.0 = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Modeling Debug|x86.Build.0 = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Release|Any CPU.Build.0 = Release|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Release|x64.ActiveCfg = Release|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Release|x64.Build.0 = Release|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Release|x86.ActiveCfg = Release|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Release|x86.Build.0 = Release|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.v3.2 Debug|x64.ActiveCfg = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.v3.2 Debug|x64.Build.0 = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.v3.2 Debug|x86.Build.0 = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Visualization Debug|x64.ActiveCfg = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Visualization Debug|x64.Build.0 = Debug|x64
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Visualization Debug|x86.ActiveCfg = Debug|x86
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}.Visualization Debug|x86.Build.0 = Debug|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -1092,4 +1168,6 @@
 	EndGlobalSection
 	GlobalSection(NestedProjects) = preSolution
+		{A9E282EA-180F-4233-B809-AEDF0787545C} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
+		{EE2034D9-6E27-48A1-B855-42D45F69A4FC} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{C36BD924-A541-4A00-AFA8-41701378DDC5} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
@@ -1118,8 +1196,8 @@
 		{4BA6068B-647C-454D-AED1-F4833034A476} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{3A5ACA94-47A7-47D6-B644-2B8A7503FCCC} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
-		{A9E282EA-180F-4233-B809-AEDF0787545C} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
+		{C75532C4-765B-418E-B09B-46D36B2ABDB1} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
-		{EE2034D9-6E27-48A1-B855-42D45F69A4FC} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
-		{C75532C4-765B-418E-B09B-46D36B2ABDB1} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
+		{589BECAE-69B0-4EB1-8C06-C073531762B7} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 	EndGlobalSection
 EndGlobal